package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.comprehensivecenter.ComprehensiveCenterDTO;
import cn.com.tenlion.systembase.pojo.dtos.institution.InstitutionDTO;
import cn.com.tenlion.systembase.pojo.dtos.school.SchoolDTO;
import cn.com.tenlion.systembase.pojo.vos.comprehensivecenter.ComprehensiveCenterVO;
import cn.com.tenlion.systembase.pojo.vos.institution.InstitutionVO;
import cn.com.tenlion.systembase.pojo.vos.school.SchoolVO;
import cn.com.tenlion.systembase.service.institution.IInstitutionService;
import cn.com.tenlion.systembase.service.school.ISchoolService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0012 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private ISchoolService schoolService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0012() {}

    @KafkaListener(topics = "C0012FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<SchoolDTO> schoolDTOList = schoolService.list(params);
        System.out.println(schoolDTOList.size());
        if(null != schoolDTOList && schoolDTOList.size() > 0) {
            for(SchoolDTO schoolDTO: schoolDTOList) {
                SchoolVO schoolVO = setData(schoolDTO);
                schoolService.saveKafka(schoolDTO.getSchoolId(), schoolVO);
            }
        }
    }

    @KafkaListener(topics = "C0012")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            SchoolDTO schoolDTO = schoolService.get(jsonObject.getString("uid"));
            SchoolVO schoolVO = setData(schoolDTO);
            schoolService.saveKafka(schoolDTO.getSchoolId(), schoolVO);
        }else {
            schoolService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private SchoolVO setData(SchoolDTO schoolDTO) {
        if(null == schoolDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        SchoolVO schoolVO = new SchoolVO();
        schoolVO.setSchoolName(schoolDTO.getSchoolName());
        schoolVO.setSchoolAddress(schoolDTO.getSchoolAddress());
        schoolVO.setRunningTypeName(schoolDTO.getRunningTypeName());
        schoolVO.setLocationCode(schoolDTO.getLocationCode());
        schoolVO.setLongitude(schoolDTO.getLongitude());
        schoolVO.setLatitude(schoolDTO.getLatitude());
        schoolVO.setGrid(schoolDTO.getGrid());
        return schoolVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}